<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Carbon;

class FunctionsController extends Controller{
    public function __construct(){}

    public static function uuidv5($namespace, $name) {
        if(!self::is_valid($namespace)) return false;

        // Get hexadecimal components of namespace
        $nhex = str_replace(array('-','{','}'), '', $namespace);

        // Binary Value
        $nstr = '';

        // Convert Namespace UUID to bits
        for($i = 0; $i < strlen($nhex); $i+=2) {
            $nstr .= chr(hexdec($nhex[$i].$nhex[$i+1]));
        }

        // Calculate hash value
        $hash = sha1($nstr . $name);

        return sprintf('%08s-%04s-%04x-%04x-%12s',

            // 32 bits for "time_low"
            substr($hash, 0, 8),

            // 16 bits for "time_mid"
            substr($hash, 8, 4),

            // 16 bits for "time_hi_and_version",
            // four most significant bits holds version number 5
            (hexdec(substr($hash, 12, 4)) & 0x0fff) | 0x5000,

            // 16 bits, 8 bits for "clk_seq_hi_res",
            // 8 bits for "clk_seq_low",
            // two most significant bits holds zero and one for variant DCE1.1
            (hexdec(substr($hash, 16, 4)) & 0x3fff) | 0x8000,

            // 48 bits for "node"
            substr($hash, 20, 12)
        );
    }

    public static function is_valid($uuid) {
        return preg_match('/^\{?[0-9a-f]{8}\-?[0-9a-f]{4}\-?[0-9a-f]{4}\-?'.
                        '[0-9a-f]{4}\-?[0-9a-f]{12}\}?$/i', $uuid) === 1;
    }

    public function generateID(){
        
    }

    public function getType($type){
        switch($type){
            case "insert":
                return "CREATE";
            break;
            case "update":
                return strtoupper($type);
            break;
            case "select":
                return "READ";
            break;
            case "delete":
                return strtoupper($type);
            break;
            default:
                return "UNKNOWN";
            break;
        }
    }

    public function registerActivity($actions, $user, $date, $line){
        $cont = 1;
        foreach($actions as $action){
            $typeStr = explode(" ", $action['query'])[0];
            $type =  $this->getType($typeStr);
            $params = json_encode($action['bindings']);
            $code = $this->uuidv5('1546058f-5a25-4334-85ae-e68f2a44bbaf', $user . $date . $cont);
            $cont++;

            $id = DB::table('S002V01TACCI')->insertGetId([
                'ACCI_NULI' => $line,
                'ACCI_COAC' => $code,
                'ACCI_TIAC' => $type,
                'ACCI_QUER' => $action['query'],
                'ACCI_PARA' => $params,
                'ACCI_FEAC' => $date,
                'ACCI_IDUS' => $user,
            ]);

            DB::table('S002V01TUSUA')->where('USUA_IDUS', '=', $user)->update([
                'USUA_ULAC' => $id
            ]);
        }
    }
}